﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="CS.aspx.cs" Inherits="CS" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
    <title></title>
    <style type="text/css">
        body
        {
            font-family: Arial;
            font-size: 10pt;
        }
        table
        {
            border: 1px solid #ccc;
            border-collapse: collapse;
            background-color: #fff;
        }
        table th
        {
            background-color: #B8DBFD;
            color: #333;
            font-weight: bold;
        }
        table th, table td
        {
            padding: 5px;
            border: 1px solid #ccc;
        }
        table, table table td
        {
            border: 0px solid #ccc;
        }
    </style>
</head>
<body>
    <form id="form1" runat="server" enctype="multipart/form-data">
    <input type="file" name="postedFile" />
    <input type="button" id="btnUpload" value="Upload" />
    <progress id="fileProgress" style="display: none"></progress>
    <hr />
    <table id="tblFiles" cellpadding="0" cellspacing="0">
        <tr>
            <th style="width: 50px">File ID</th>
            <th style="width: 120px">File Name</th>
            <th style="width: 80px">Download</th>
        </tr>
        <tr>
            <td></td>
            <td></td>
            <td></td>
        </tr>
    </table>

    <script type="text/javascript" src="https://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js"></script>
    <script type="text/javascript">
        $(function () {
            GetFiles();
        });
        function GetFiles() {
            $.ajax({
                type: "POST",
                url: "HandlerCS.ashx",
                data: '{}',
                contentType: "application/json; charset=utf-8",
                dataType: "json",
                success: function (files) {
                    $(files).each(function(){
                        AppendRow(this.id, this.name);
                    });
                },
                failure: function (r) {
                    alert(r.responseText);
                },
                error: function (r) {
                    alert(r.responseText);
                }
            });
        };

        function AppendRow(id, name) {
            var row = $("#tblFiles tbody tr:last-child");

            //Remove if the row is dummy row.
            if (row.find("td:empty").length > 0) {
                row.remove();
            }

            row = row.clone();
            $("td", row).eq(0).html(id);
            $("td", row).eq(1).html(name);
            $("td", row).eq(2).html("");
            var a = $("<a />");
            a.html("Download");
            a[0].href = 'HandlerCS.ashx?FileId=' + id;
            $("td", row).eq(2).append(a);
            $("#tblFiles tbody").append(row);
        };

        $("body").on("click", "#btnUpload", function () {
            $.ajax({
                url: 'HandlerCS.ashx',
                type: 'POST',
                data: new FormData($('form')[0]),
                cache: false,
                contentType: false,
                processData: false,
                success: function (file) {
                    $("#fileProgress").hide();
                    AppendRow(file.id, file.name);
                },
                xhr: function () {
                    var fileXhr = $.ajaxSettings.xhr();
                    if (fileXhr.upload) {
                        $("progress").show();
                        fileXhr.upload.addEventListener("progress", function (e) {
                            if (e.lengthComputable) {
                                $("#fileProgress").attr({
                                    value: e.loaded,
                                    max: e.total
                                });
                            }
                        }, false);
                    }
                    return fileXhr;
                }
            });
        });
    </script>
    </form>
</body>
</html>
