﻿<%@ WebHandler Language="VB" Class="HandlerVB" %>

Imports System
Imports System.IO
Imports System.Net
Imports System.Web
Imports System.Data
Imports System.Configuration
Imports System.Data.SqlClient
Imports System.Collections.Generic
Imports System.Web.Script.Serialization

Public Class HandlerVB : Implements IHttpHandler
    
    Public Sub ProcessRequest(ByVal context As HttpContext) Implements IHttpHandler.ProcessRequest
        Dim fileId As Integer = 0
        Integer.TryParse(context.Request.QueryString("FileId"), fileId)

        'Check if Request is to Upload the File.
        If context.Request.Files.Count > 0 Then
            Dim postedFile As HttpPostedFile = context.Request.Files(0)

            'Convert the File data to Byte Array.
            Dim bytes As Byte()
            Using br As BinaryReader = New BinaryReader(postedFile.InputStream)
                bytes = br.ReadBytes(postedFile.ContentLength)
            End Using

            'Insert the File to Database Table.
            Dim fileName As String = Path.GetFileName(postedFile.FileName)
            Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
            Using conn As SqlConnection = New SqlConnection(constr)
                Dim sql As String = "INSERT INTO tblFiles VALUES(@Name, @ContentType, @Data)"
                sql += " SELECT SCOPE_IDENTITY()"

                Using cmd As SqlCommand = New SqlCommand(sql, conn)
                    cmd.Parameters.AddWithValue("@Name", fileName)
                    cmd.Parameters.AddWithValue("@ContentType", postedFile.ContentType)
                    cmd.Parameters.AddWithValue("@Data", bytes)
                    conn.Open()
                    fileId = Convert.ToInt32(cmd.ExecuteScalar())
                    conn.Close()
                End Using
            End Using

            'Send File details in a JSON Response.
            Dim json As String = New JavaScriptSerializer().Serialize(New With {
                .id = fileId,
                .name = fileName
            })
            context.Response.StatusCode = CInt(HttpStatusCode.OK)
            context.Response.ContentType = "text/json"
            context.Response.Write(json)
            context.Response.End()
            
        ElseIf fileId > 0 Then 'Check if Request is to Download the File.
            Dim bytes As Byte()
            Dim fileName, contentType As String
            Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
            Using conn As SqlConnection = New SqlConnection(constr)
                Using cmd As SqlCommand = New SqlCommand()
                    cmd.CommandText = "SELECT Name, Data, ContentType FROM tblFiles WHERE Id=@Id"
                    cmd.Parameters.AddWithValue("@Id", fileId)
                    cmd.Connection = conn
                    conn.Open()
                    Using sdr As SqlDataReader = cmd.ExecuteReader()
                        sdr.Read()
                        bytes = CType(sdr("Data"), Byte())
                        contentType = sdr("ContentType").ToString()
                        fileName = sdr("Name").ToString()
                    End Using
                    conn.Close()
                End Using
            End Using

            context.Response.StatusCode = CInt(HttpStatusCode.OK)
            context.Response.Clear()
            context.Response.Buffer = True
            context.Response.Charset = ""
            context.Response.Cache.SetCacheability(HttpCacheability.NoCache)

            'Set the File Content Type.
            context.Response.ContentType = contentType
            
            'Set the Content Disposition Header Value and FileName.
            context.Response.AppendHeader("Content-Disposition", "attachment; filename=" & fileName)
            
            'Set the Response Content.
            context.Response.BinaryWrite(bytes)
            context.Response.Flush()
            context.Response.End()
            
        Else 'Request to get all Files.
            
            'Fetch all Files from Database Table.
            Dim files As List(Of Object) = New List(Of Object)()
            Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
            Using conn As SqlConnection = New SqlConnection(constr)
                Using cmd As SqlCommand = New SqlCommand("SELECT Id, Name FROM tblFiles", conn)
                    conn.Open()
                    Using sdr As SqlDataReader = cmd.ExecuteReader()
                        While sdr.Read()
                            files.Add(New With {
                                .id = sdr("Id"),
                                .name = sdr("Name")
                            })
                        End While
                    End Using
                    conn.Close()
                End Using
            End Using

            'Send File data in JSON format for Download.
            Dim json As String = New JavaScriptSerializer().Serialize(files)
            context.Response.StatusCode = CInt(HttpStatusCode.OK)
            context.Response.ContentType = "text/json"
            context.Response.Write(json)
            context.Response.End()
        End If
    End Sub
 
    Public ReadOnly Property IsReusable() As Boolean Implements IHttpHandler.IsReusable
        Get
            Return False
        End Get
    End Property

End Class